.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm
LOOP_COUNT	= 1000000

CmpArray1	PROTO: DWORD, :DWORD
CmpArray2	PROTO: DWORD, :DWORD
CmpArray3	PROTO: DWORD, :DWORD

.data
Src1	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos."
align 16
Src2	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos."

.code
start:
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke CmpArray1, offset Src1, offset Src2
	counter_end
	print str$(eax), 9, "cycles for CmpArray1", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke CmpArray2, offset Src1, offset Src2
	counter_end
	print str$(eax), 9, "cycles for CmpArray2", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke CmpArray3, offset Src1, offset Src2
	counter_end
	print str$(eax), 9, "cycles for CmpArray3", 13, 10

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

Option Prologue:NONE
Option Epilogue:NONE
align 16
CmpArray1 proc strA, strB	; Lingo
	pop ecx
	pop eax
	pop edx
	movdqa xmm0, [eax]
	movdqa xmm1, [eax+16]
	pcmpeqd xmm0, [edx]
	pcmpeqd xmm1, [edx+16]
	pmovmskb eax, xmm0
	pmovmskb edx, xmm1
	shl eax, 16
	add eax, edx
	jmp ecx
CmpArray1 endp

align 16
CmpArray2 proc strA, strB	; Lingo but "normal" ret
	mov eax, [esp+4]
	mov edx, [esp+8]
	movdqa xmm0, [eax]
	movdqa xmm1, [eax+16]
	pcmpeqd xmm0, [edx]
	pcmpeqd xmm1, [edx+16]
	pmovmskb eax, xmm0
	pmovmskb edx, xmm1
	shl eax, 16
	add eax, edx
	ret 8
CmpArray2 endp

align 16
CmpArray3 proc strA, strB	; Clive
	pop ecx
	pop eax
	pop edx
	movdqa xmm0, [eax]
	movdqa xmm2, [edx]
	movdqa xmm1, [eax+16]
	movdqa xmm3, [edx+16]
	pcmpeqd xmm0, xmm2
	pmovmskb eax, xmm0
	pcmpeqd xmm1, xmm3
	pmovmskb edx, xmm1
	and eax, edx
	jmp ecx
CmpArray3 endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]